#pragma once
#include "DataStructures.h"
#include <vector>
#include <fstream>
#include <vector>
#include "DataStructures.h"

class MeshLoader {
protected:
    std::vector<Node> nodes;
    std::vector<Element> elements;
    std::vector<ElemBoundary> boundaries;
public:
    virtual void LoadMesh(const std::string&) = 0;
    MeshLoader() = default;
    virtual ~MeshLoader() = default;



    std::vector<Node>& Get_Nodes();
    std::vector<Element>& Get_Elements();
    std::vector<ElemBoundary>& Get_boundaries();

    
    std::vector<int> Get_Elements_by_ID(int p_node_id1, int p_node_id2, int p_node_id3);

    std::vector<int> Get_Elements_by_edge(int p_node_id1, int p_node_id2);

    std::vector<int> Get_elems_by_material(int p_material) const;
    
    std::set<int> Get_nodes_by_surface(int p_surface);
 
    std::vector<int> Get_boundaries_by_surface(int p_surface) const;

    void Insert_newNodes();
   

    std::vector<std::set<int>> Get_Nodes_Neighbors() const;
    Node Get_Node_by_ID(int p_id);

private:
 
    std::array<double, 3> Get_middle_of_edge(const Edge&);
    Node Get_middle_node(const Edge&);
    Node& Get_node_by_ID(int);
    std::array<double, 3> Get_ords_node_by_ID(int);

};
