#include "MeshLoader.h"
#include "MeshLoader.h"
#include "AneuMeshLoader.h"
#include "Exception.h"
#include "DataStructures.h"
#include <iostream>
#include <string>
#include <fstream>
#include <algorithm>


int main()
{
	MeshLoader* mesh_loader = new AneuMeshLoader; 
	mesh_loader->LoadMesh("cylsphere.aneu");

	std::vector<Node> nodes = mesh_loader->Get_Nodes();
	std::vector<Element> finite_elements = mesh_loader->Get_Elements();
	std::vector<ElemBoundary> boundaries = mesh_loader->Get_boundaries();


	std::vector<int> elems_by_ID = mesh_loader->Get_Elements_by_ID(1, 2, 3);
	std::vector<int> elems_by_material = mesh_loader->Get_elems_by_material(1);


	std::vector<int> elems_by_edge = mesh_loader->Get_Elements_by_edge(1, 2);

	std::set<int> nodes_by_surface = mesh_loader->Get_nodes_by_surface(1);

	std::vector<int> boundary_by_surface = mesh_loader->Get_boundaries_by_surface(2);

	mesh_loader->Insert_newNodes();

	auto neighbor_nodes = mesh_loader->Get_Nodes_Neighbors();

	

	delete mesh_loader;
	return 0;
}
